//To log onto the Server side Program type
//java ClientButton IPaddress
//eg. java ClientButton 192.168.190.184

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class ClientPlot extends JFrame implements ActionListener{

   final static int MAX_COL=10,MAX_ROW=10,SIZE=4;

   JTextField jtf;
   String str,response;
   ImageIcon icon;
   static Client client;
   JButton b[][]=new JButton[MAX_ROW][MAX_COL];
   BufferedReader reader;
   PrintWriter writer;
   int countClient=0,countServer=0;
   int height[]=new int[MAX_ROW];

   public void init(){
      JFrame f=new JFrame();

      f.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
           setVisible(false);
           System.exit(0);
        }
      });

      reader =new BufferedReader (new InputStreamReader (client.in));

      Container contentPane=f.getContentPane();
      contentPane.setLayout(new GridBagLayout());
      GridBagConstraints gbc=new GridBagConstraints();

      icon=new ImageIcon("T.jpg");

      gbc.gridwidth=1;
      gbc.gridheight=1;

      gbc.fill=GridBagConstraints.BOTH;

      for(int y=0;y<MAX_ROW;y++){
         for(int x=0;x<MAX_COL;x++){
            gbc.gridx=x;
            gbc.gridy=y+2;
            b[y][x]=new JButton(icon);
            b[y][x].setActionCommand(""+x);
               b[y][x].addActionListener(this);
            contentPane.add(b[y][x],gbc);
         }
      }

      gbc.gridx=3;
      gbc.gridy=MAX_ROW+2;
      gbc.gridwidth=3;
      jtf=new JTextField("Client's Turn",15);
      contentPane.add(jtf,gbc);

      gbc.gridwidth=10;
      gbc.gridx=0;
      gbc.gridy=0;

      icon=new ImageIcon("pfclient.jpg");
      JLabel jl=new JLabel(icon);
        contentPane.add(jl,gbc);


      f.setSize(600,600);
      f.setVisible(true);
      f.show();

      while(true){
      try{
         if(countServer<countClient){
            response=reader.readLine();
            countServer++;
            icon=new ImageIcon("not.jpg");
            int i=Integer.parseInt(response);

            int j=height[Integer.parseInt(response)];

            b[j][i].setIcon(icon);
            b[j][i].setActionCommand("not");
            b[j][i].removeActionListener(this);
            height[Integer.parseInt(response)]++;

            if (check("not",j,i)){
               response="Server has won !!!";
               writer =new PrintWriter (new OutputStreamWriter (client.out),true);
               writer.println(response);
               jtf.setText("Server has won !!!");
               stopProgram();
               break;

            }
            jtf.setText("Client's Turn");
         }
      }catch(IOException e){}
      }


   }

   public boolean check(String str, int y, int x){
      //boolean result;
      int count=0;

      for(int i=0;i<MAX_COL;i++){

         if(b[y][i].getActionCommand().equals(str))
            count++;
         else
            count=0;
         if(count==SIZE) return (true);
      }

      count=0;

      for(int j=0;j<MAX_ROW;j++){
         if(b[j][x].getActionCommand().equals(str))
            count++;
         else
            count=0;
         if (count==SIZE) return (true);
      }

      count=0;
      int i=x,j=y;
      while((i>0)&(j>0)){
         i--;j--;
      }

      while((i!=MAX_COL-1)&(j!=MAX_ROW-1)){
         if(b[j][i].getActionCommand().equals(str))
            count++;
         else
            count=0;
         if (count==SIZE) return (true);
         i++;j++;
      }

      count=0;
      i=x;j=y;
      while((i!=MAX_COL-1)&(j>0)){
         i++;j--;
      }

      while((i>0)&(j!=MAX_ROW-1)){
         if(b[j][i].getActionCommand().equals(str))
            count++;
         else
            count=0;
         if (count==SIZE) return (true);
         i--;j++;
      }

      return(false);


   }

   public void actionPerformed(ActionEvent ae){
      if(countClient>countServer)
         return;
      if (height[Integer.parseInt(ae.getActionCommand())]==MAX_ROW)
         return;

      countClient++;

      int j=height[Integer.parseInt(ae.getActionCommand())];

      jtf.setText("Server's Turn");
      writer =new PrintWriter (new OutputStreamWriter (client.out),true);
      icon=new ImageIcon("cross.jpg");
      int i=Integer.parseInt(ae.getActionCommand());
      str=ae.getActionCommand();

      b[j][i].setIcon(icon);
      b[j][i].setActionCommand("cross");
      b[j][i].removeActionListener(this);
      height[Integer.parseInt(ae.getActionCommand())]++;
      if (check("cross",j,i)){
         jtf.setText("Client has won !!!");
         writer.println(str+"Client has won !!!");
         stopProgram();
      }



      writer.println(str);

   }

   public void stopProgram(){
      for(int x=0;x<MAX_COL;x++)
         for (int y=0;y<MAX_ROW;y++)
            b[y][x].removeActionListener(this);
   }

   public static void main(String args[]){
      client= new Client(args[0],8010);
      new ClientPlot().init();
   }
}


class Client {
   public InputStream in;
   public OutputStream out;

   private Socket client;

   public Client (String host, int port) {
      try {
         client=new Socket(host, port);
         System.out.println("Client socket: "+ client);
         in  = client.getInputStream();
         out = client.getOutputStream();
      } catch (IOException e) {
         System.out.println("IOExc :"+ e);
      }
   }
}
